% Basics of Simulation

% Inversion Method for the Exp(lam) distribution
% U ~ U(0,1) => X=F^{-1}(U) ~ F(lam), F Exponential

sim_Exp=function(n, lam) {
u = runif(n)
x= -(log(1-u))/lam

return(x)
}

x=sim_Exp(1000,1)
mean(x)
var(x)
hist(x)

y=sim_Exp(1000,3)
mean(x)
var(x)
hist(y)

% Transformation of Variables: Simulate from the Gamma distribution
% Y_1,...,Y_m ~ Exp(theta) => X = sum(Y_i) ~ Gamma(m, theta)

sim_Gamma=function(n,m,theta) {
x=rep(0,1,n)
for (i in 1:n) { 
	u = runif(m)
	y = -(log(1-u))/theta
	x[i]=sum(y)
}

return(x)
}

x=sim_Gamma(1000,10,3)
mean(x)
var(x)
hist(x)
